-- -----------------------------------------------------------------------------
--[[----------------------------------------------------------------------------

                    __    ,- WOEZ CALENDAR INVIT
                   /✷_)      Made with ❤ by woOtzee
           _.---._/ /        
         /         /         
      _/         |/          
     /__.-|_|--|_| 

                                     Feel free to contact me / hello@wootzee.com
-- -------------------------------------------------------------------------]]--
-- -----------------------------------------------------------------------------

if not IsAddOnLoaded("Blizzard_Calendar") then UIParentLoadAddOn("Blizzard_Calendar") end

-- -----------------------------------------------------------------------------

local ADDON_NAME, ns = ...
local WOEZ_D,WOEZ_O,WOEZ_F,L = ns.datas,ns.functions,ns.frames,ns.locales

-- -----------------------------------------------------------------------------
-- EVENTS
-- -----------------------------------------------------------------------------

for _,event in pairs(WOEZ_D.events) do
    WOEZ_O:DEBUG('REGISTER',event)
    WOEZ_F.main:RegisterEvent(event)
end

local margin  = (ElvUI and 0 or 3)

WOEZ_F.main:SetScript("OnEvent",function(self,event,...)
    local arg = ...  
    WOEZ_O:DEBUG('FIRE',event,tostring(arg))
    ----------------------------------------------------------------------------
    ----------------------------------------------------------------------------
    if event == "PLAYER_LOGIN" then
        WOEZ_O:SHOW_WELCOME() 
        WOEZ_O:GET_GUILD() 
        WOEZ_O:GET_GUILD_TABLE() 
    ----------------------------------------------------------------------------
    elseif event == "PLAYER_GUILD_UPDATE" then
        WOEZ_O:GET_GUILD() 
        WOEZ_O:SET_ROSTER()
    ----------------------------------------------------------------------------
    elseif event == "GUILD_ROSTER_UPDATE" then
        if arg == true then 
            WOEZ_O:REFRESH_ROSTER()
        end
    ----------------------------------------------------------------------------
    elseif event == "GROUP_ROSTER_UPDATE" then
        WOEZ_O:GET_GUILD_TABLE() 
    ----------------------------------------------------------------------------
    elseif event == "CLUB_ADDED" or event == "CLUB_REMOVED" or event == "CLUB_MEMBER_ADDED" or event == "CLUB_MEMBER_REMOVED" then
        WOEZ_O:GET_GUILD_TABLE() 

    elseif event == "CLUB_MEMBER_PRESENCE_UPDATED" then
        WOEZ_O:GET_COMMUNITY_TABLE(arg)

    ----------------------------------------------------------------------------
    ----------------------------------------------------------------------------
    elseif event == "CALENDAR_OPEN_EVENT" then
        if arg == "PLAYER" or arg == "GUILD_EVENT" or arg=="COMMUNITY_EVENT" then 
            WOEZ_D.isOpen = true
            WOEZ_O:GET_EVENT() 
            WOEZ_F.main:ClearAllPoints()
            if WOEZ_D.canEdit then
                WOEZ_F.main:SetPoint(   "TOPLEFT",CalendarCreateEventFrame,   "TOPRIGHT",32, 0-margin)
                WOEZ_F.main:SetPoint("BOTTOMLEFT",CalendarCreateEventFrame,"BOTTOMRIGHT",32, 0+margin)
            else
                WOEZ_F.main:SetPoint(   "TOPLEFT",CalendarViewEventFrame,   "TOPRIGHT",32, 0-margin)
                WOEZ_F.main:SetPoint("BOTTOMLEFT",CalendarViewEventFrame,"BOTTOMRIGHT",32, 0+margin)
            end
            WOEZ_F.main:SetMinResize(WOEZ_D.MinResizW,WOEZ_F.main:GetHeight())
            WOEZ_F.main:SetMaxResize(WOEZ_D.MaxResizW,GetScreenHeight()*3/4)
            
        else
            WOEZ_D.isOpen = false
            WOEZ_O:CLOSE_ROSTER() 
        end
        WOEZ_O:SET_ROSTER() 
    elseif event == "CALENDAR_CLOSE_EVENT" then
        WOEZ_O:CLOSE_ROSTER() 
    ----------------------------------------------------------------------------
    ----------------------------------------------------------------------------
    elseif event == "CALENDAR_UPDATE_ERROR" then  
        if arg == "CALENDAR_ERROR_EVENT_PASSED" or arg == "CALENDAR_ERROR_NO_COMMUNITY_INVITES" or arg == "CALENDAR_ERROR_NO_GUILD_INVITES" or arg == "CALENDAR_ERROR_INVITES_DISABLED" then 
            WOEZ_O:PROGRESS_STOP()
        end
        WOEZ_O:GET_EVENT() 
        WOEZ_O:REFRESH_ROSTER()
    ----------------------------------------------------------------------------
    elseif event == "CALENDAR_UPDATE_ERROR_WITH_COUNT" then  
        WOEZ_O:PROGRESS_STOP()
        WOEZ_O:REFRESH_ROSTER()
    ----------------------------------------------------------------------------
    elseif event == "CALENDAR_UPDATE_INVITE_LIST" then
        WOEZ_O:REFRESH_ROSTER()
    elseif event == "CALENDAR_UPDATE_EVENT" then
        WOEZ_O:GET_EVENT() 
        WOEZ_O:REFRESH_ROSTER()
    ----------------------------------------------------------------------------
    ----------------------------------------------------------------------------
    elseif event == "CALENDAR_ACTION_PENDING" then 
        if arg == false then
            if WOEZ_D.InPrgrss then WOEZ_D.toPrgrss = true end
        else
            WOEZ_D.toPrgrss = false
            WOEZ_D.InPrgrss = true
        end 
    ----------------------------------------------------------------------------
    end
    return 
end)

-- -----------------------------------------------------------------------------
-- UPDATE
-- -----------------------------------------------------------------------------

WOEZ_F.main:SetScript("OnUpdate",function(self,elapsed)
    WOEZ_D.lastUpdat = WOEZ_D.lastUpdat + elapsed
    if WOEZ_D.lastUpdat > .8 then
        if WOEZ_D.InPrgrss and WOEZ_D.toPrgrss then
            WOEZ_D.InPrgrss = false
            WOEZ_D.toPrgrss = false
        elseif WOEZ_D.toProcess > 0 and not WOEZ_D.InPrgrss then
            WOEZ_O:DO_INVITS() 
        end        
        WOEZ_D.lastUpdat = 0
     end
end)

-- -----------------------------------------------------------------------------
-- -----------------------------------------------------------------------------
-- -----------------------------------------------------------------------------