-- -----------------------------------------------------------------------------

local ADDON_NAME, ns = ...
local WOEZ_D,WOEZ_O,WOEZ_F,L = ns.datas,ns.functions,ns.frames,ns.locales

-- WOEZ_O:FRAM(name,type,where,opt, z,x,y,yy,zz,w,h)
-- WOEZ_O:ICON(name,where,ico,      z,x,y,      w,h)
-- WOEZ_O:FONT(name,where,          z,x,y,      w,h,font,justifyH)
-- WOEZ_O:FADE(name,where,allpoint,f)

-- -----------------------------------------------------------------------------
-- MAIN
-- -----------------------------------------------------------------------------

WOEZ_F.main       = WOEZ_O:FRAM("WOEZframe","Frame",UIParent,nil,
                                nil,nil,nil,nil,nil, -- position
                                WOEZ_D.sizes.PANNEL,500) -- size
WOEZ_F.main:Hide()
WOEZ_F.main_f     = WOEZ_O:FADE("WOEZmainfade",WOEZ_F.main,true,.4)
WOEZ_F.main:SetResizable(true)
WOEZ_F.main:SetMinResize(WOEZ_D.MinResizW, 0)
WOEZ_F.main:SetMaxResize(WOEZ_D.MaxResizW, 0)

WOEZ_F.main_rb    = WOEZ_O:FRAM("WOEZframeRB","Button",WOEZ_F.main,nil,
                                "BOTTOMRIGHT", 0,0,nil,nil, -- position
                                WOEZ_D.fonts.TXT,WOEZ_D.fonts.TXT) -- size
WOEZ_F.main_rb:SetNormalTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Up")
WOEZ_F.main_rb:SetHighlightTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Highlight")
WOEZ_F.main_rb:SetPushedTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Down")  
WOEZ_F.main_rb:SetScript("OnMouseDown", function() WOEZ_F.main:StartSizing("BOTTOMRIGHT")  end)
WOEZ_F.main_rb:SetScript("OnMouseUp"  , function() 
    WOEZ_F.main:StopMovingOrSizing()  
    WO_ez_DBC.width = WOEZ_F.main:GetWidth() 
    WOEZ_D.sizes.PANNEL = WOEZ_F.main:GetWidth() 
    WOEZ_O:RESET_SIZE()
end)
WOEZ_F.main_rb:SetFrameStrata("HIGH")

-- -----------------------------------------------------------------------------
-- IN PROGRESS ZONE
-- -----------------------------------------------------------------------------

WOEZ_F.progress   = WOEZ_O:FRAM("WOEZprogress","Frame",WOEZ_F.main,nil) 
WOEZ_F.progress:SetPoint("TOPLEFT",WOEZ_F.main, "BOTTOMLEFT",0,-(WOEZ_D.sizes.MARGES))
WOEZ_F.progress:SetPoint("BOTTOMRIGHT",WOEZ_F.main, "BOTTOMRIGHT",0,-(WOEZ_D.sizes.PANNELPRGSS_H+WOEZ_D.sizes.MARGES))
WOEZ_F.progress_f = WOEZ_O:FADE("WOEZprogressfade",WOEZ_F.progress,true,.7)
WOEZ_F.progress_t = WOEZ_O:FONT("WOEZprogresstext",WOEZ_F.progress,
                                "LEFT",WOEZ_F.progress,"LEFT",(WOEZ_D.sizes.MARGES*2),0, -- position
                                nil,nil, -- w,h
                                WOEZ_D.fonts.TTL_F ,"LEFT")
WOEZ_F.progress_t:SetPoint("RIGHT",WOEZ_F.progress,"RIGHT",-(WOEZ_D.fonts.TXT_22+WOEZ_D.sizes.MARGES*2),0)
WOEZ_F.progress_t:SetText("UPDATING...")
WOEZ_F.progress_t:SetTextColor(1,1,1,1) 

WOEZ_F.progress_b = WOEZ_O:FRAM("WOEZprogressbtn","Button",WOEZ_F.progress,"UIPanelButtonTemplate",
                                "RIGHT",-(WOEZ_D.sizes.MARGES+4),0,nil,nil, -- position
                                WOEZ_D.fonts.TXT_22,WOEZ_D.fonts.TXT_22) -- size      
WOEZ_F.progress_b:SetScript("OnClick", function() WOEZ_O:PROGRESS_STOP() WOEZ_O:REFRESH_ROSTER() end) 
WOEZ_F.progress_b:SetFrameStrata("TOOLTIP") 
WOEZ_F.progress_b:SetText("x") 
WOEZ_F.progress:Hide()

-- -----------------------------------------------------------------------------
-- INFOS TOP
-- -----------------------------------------------------------------------------

WOEZ_F.infos      = WOEZ_O:FRAM("WOEZinfos","Frame",WOEZ_F.main,nil,
                                "TOPLEFT",WOEZ_D.sizes.MARGES,-(WOEZ_D.sizes.MARGES)) -- size
WOEZ_F.infos:SetPoint("BOTTOMRIGHT",WOEZ_F.main, "TOPRIGHT",-(WOEZ_D.sizes.MARGES),-(WOEZ_D.sizes.PANNELINFOS_H+WOEZ_D.sizes.MARGES))
WOEZ_F.infos_f    = WOEZ_O:FADE("WOEZinfosfade",WOEZ_F.infos,true,.6)

-- -----------------------------------------------------------------------------

WOEZ_F.infos_NCmmg_i = WOEZ_O:ICON("WOezinfosNCmmg_i",WOEZ_F.infos,WOEZ_D.FOLDR .."st_no.tga",  
                                "RIGHT",-(WOEZ_D.sizes.MMARGS),0,
                                WOEZ_D.sizes.ICNSUM,WOEZ_D.sizes.ICNSUM)

WOEZ_F.infos_NCmmg_t = WOEZ_O:FONT("WOezinfosNCmmg_t",WOEZ_F.infos,
                                "RIGHT",WOEZ_F.infos_NCmmg_i,"LEFT",0,0,  
                                nil,nil, WOEZ_D.fonts.TTL_F ,"RIGHT")

-- -----------------------------------------------------------------------------

WOEZ_F.infos_NRply_i = WOEZ_O:ICON("WOezinfosNRply_i",WOEZ_F.infos,WOEZ_D.FOLDR .."st_dunno.tga",  
                                nil,nil,nil,   WOEZ_D.sizes.ICNSUM,WOEZ_D.sizes.ICNSUM)
WOEZ_F.infos_NRply_t = WOEZ_O:FONT("WOezinfosNRply_t",WOEZ_F.infos,
                                "RIGHT",WOEZ_F.infos_NRply_i,"LEFT",0,0,  
                                nil,nil, WOEZ_D.fonts.TTL_F ,"RIGHT")

-- -----------------------------------------------------------------------------

WOEZ_F.infos_Commg_i = WOEZ_O:ICON("WOezinfosCommg_i",WOEZ_F.infos,nil,  
                                nil,nil,nil,   WOEZ_D.sizes.ICNSUM,WOEZ_D.sizes.ICNSUM)
WOEZ_F.infos_Commg_t = WOEZ_O:FONT("WOezinfosCommg_t",WOEZ_F.infos,
                                "RIGHT",WOEZ_F.infos_Commg_i,"LEFT",0,0,  
                                nil,nil, WOEZ_D.fonts.TTL_F ,"RIGHT")

-- -----------------------------------------------------------------------------

WOEZ_F.infos_Invit_t = WOEZ_O:FONT("WOezinfosInvit_t",WOEZ_F.infos,
                                "LEFT",WOEZ_F.infos,"LEFT",WOEZ_D.sizes.MARGES,0,  
                                nil,nil, WOEZ_D.fonts.TTL_F ,"LEFT")

-- -----------------------------------------------------------------------------

WOEZ_F.infos_NRply_i:SetPoint("RIGHT",WOEZ_F.infos_NCmmg_t, "LEFT",-(WOEZ_D.sizes.MMARGS),0)
WOEZ_F.infos_Commg_i:SetPoint("RIGHT",WOEZ_F.infos_NRply_t, "LEFT",-(WOEZ_D.sizes.MMARGS),0)
WOEZ_F.infos_Invit_t:SetPoint("RIGHT",WOEZ_F.infos_Commg_t, "LEFT",-(WOEZ_D.sizes.MARGES),0)

-- -----------------------------------------------------------------------------
-- BOTTOM
-- -----------------------------------------------------------------------------

WOEZ_F.bottom      = WOEZ_O:FRAM("WOEZbottom","Frame",WOEZ_F.infos,nil)
WOEZ_F.bottom:SetPoint("TOPLEFT"    ,WOEZ_F.main, "BOTTOMLEFT"  ,WOEZ_D.sizes.MARGES,WOEZ_D.sizes.PANNELINFOS_H+WOEZ_D.sizes.MARGES)
WOEZ_F.bottom:SetPoint("BOTTOMRIGHT",WOEZ_F.main, "BOTTOMRIGHT" ,-(WOEZ_D.sizes.MARGES),WOEZ_D.sizes.MARGES)
WOEZ_F.bottom_f    = WOEZ_O:FADE("WOEZbottomfade",WOEZ_F.bottom,true,.6)

WOEZ_F.summa_rangs = WOEZ_O:ICON("WOezsummarangs",WOEZ_F.bottom,WOEZ_D.FOLDR .."R.tga",
                                "RIGHT",-(WOEZ_D.sizes.MARGES),0,WOEZ_D.sizes.ICNSUM*1.24,WOEZ_D.sizes.ICNSUM*1.24)
WOEZ_F.sum_rangs_t = WOEZ_O:FONT("WOezsummrangst",WOEZ_F.bottom,
                                "RIGHT",WOEZ_F.summa_rangs,"LEFT",0,0,
                                nil,nil,WOEZ_D.fonts.TTL_F,"LEFT")

WOEZ_F.summa_meles = WOEZ_O:ICON("WOezsummameles",WOEZ_F.bottom,WOEZ_D.FOLDR .."M.tga",
                                nil,nil,nil,  WOEZ_D.sizes.ICNSUM*1.24,WOEZ_D.sizes.ICNSUM*1.24)
WOEZ_F.sum_meles_t = WOEZ_O:FONT("WOezsummmelest",WOEZ_F.bottom,
                                "RIGHT",WOEZ_F.summa_meles,"LEFT",0,0,
                                nil,nil,WOEZ_D.fonts.TTL_F,"LEFT")

WOEZ_F.summa_heals = WOEZ_O:ICON("WOezsummaheals",WOEZ_F.bottom,WOEZ_D.FOLDR .."H.tga",
                                nil,nil,nil,  WOEZ_D.sizes.ICNSUM*1.24,WOEZ_D.sizes.ICNSUM*1.24)
WOEZ_F.sum_heals_t = WOEZ_O:FONT("WOezsummhealst",WOEZ_F.bottom,
                                "RIGHT",WOEZ_F.summa_heals,"LEFT",0,0,
                                nil,nil,WOEZ_D.fonts.TTL_F,"LEFT")

WOEZ_F.summa_tanks = WOEZ_O:ICON("WOezsummatanks",WOEZ_F.bottom,WOEZ_D.FOLDR .."T.tga",
                                nil,nil,nil,  WOEZ_D.sizes.ICNSUM*1.24,WOEZ_D.sizes.ICNSUM*1.24)
WOEZ_F.sum_tanks_t = WOEZ_O:FONT("WOezsummtankst",WOEZ_F.bottom,
                                "RIGHT",WOEZ_F.summa_tanks,"LEFT",0,0,
                                nil,nil,WOEZ_D.fonts.TTL_F,"LEFT")


WOEZ_F.bottnc     = WOEZ_O:FRAM("WOEZbottom_","CheckButton",WOEZ_F.bottom,"ChatConfigCheckButtonTemplate","LEFT",WOEZ_D.fonts.TXT_05,0,nil,nil,WOEZ_D.fonts.TXT_14,WOEZ_D.fonts.TXT_14)
WOEZ_F.bottxt     = WOEZ_O:FONT("WOEZbottom_txt",WOEZ_F.bottnc,"LEFT",WOEZ_F.bottnc,"RIGHT",WOEZ_D.sizes.MMARGS,0,nil,nil,WOEZ_D.fonts.TTL_F,"LEFT")

WOEZ_F.bottxt:SetText(L["ONLY INVITED"])   
       
WOEZ_F.bottnc:SetScript("OnClick", function() 
    if WO_ez_DBC.only_invited then  WO_ez_DBC.only_invited = nil   WOEZ_F.bottxt:SetTextColor(.4,.4,.4,1)    
                              else  WO_ez_DBC.only_invited = true  WOEZ_F.bottxt:SetTextColor(1,1,1,1)    end 
    WOEZ_O:SET_ROSTER() 
end)

-- -----------------------------------------------------------------------------

WOEZ_F.summa_meles:SetPoint("RIGHT",WOEZ_F.sum_rangs_t, "LEFT",-(WOEZ_D.sizes.MMARGS),0)
WOEZ_F.summa_heals:SetPoint("RIGHT",WOEZ_F.sum_meles_t, "LEFT",-(WOEZ_D.sizes.MMARGS),0)
WOEZ_F.summa_tanks:SetPoint("RIGHT",WOEZ_F.sum_heals_t, "LEFT",-(WOEZ_D.sizes.MMARGS),0)
WOEZ_F.bottxt:SetPoint("RIGHT",WOEZ_F.sum_tanks_t,"LEFT",-(WOEZ_D.sizes.MMARGS),0)

-- -----------------------------------------------------------------------------
-- MARGES    
-- -----------------------------------------------------------------------------

WOEZ_F.margb      = WOEZ_O:FRAM("WOEZmargb","Frame",WOEZ_F.main,nil) 
WOEZ_F.margb:SetPoint("TOPLEFT"     ,WOEZ_F.bottom, "TOPLEFT" ,0,WOEZ_D.sizes.MARGES)
WOEZ_F.margb:SetPoint("BOTTOMRIGHT" ,WOEZ_F.bottom, "TOPRIGHT",0,WOEZ_D.sizes.MMARGS)
WOEZ_F.margb_f    = WOEZ_O:FADE("WOEZmargbfade",WOEZ_F.margb,true,.6)

WOEZ_F.margt      = WOEZ_O:FRAM("WOEZmargt","Frame",WOEZ_F.main,nil) 
WOEZ_F.margt:SetPoint("TOPLEFT"     ,WOEZ_F.infos, "BOTTOMLEFT" ,0,-(WOEZ_D.sizes.MMARGS))
WOEZ_F.margt:SetPoint("BOTTOMRIGHT" ,WOEZ_F.infos, "BOTTOMRIGHT",0,-(WOEZ_D.sizes.MARGES))
WOEZ_F.margt_f    = WOEZ_O:FADE("WOEZmargtfade",WOEZ_F.margt,true,.6)

-- -----------------------------------------------------------------------------
-- SCROLL FRAME    
-- -----------------------------------------------------------------------------

WOEZ_F.scrollf    = WOEZ_O:FRAM("WOEZscrollf","ScrollFrame",WOEZ_F.infos,nil)
WOEZ_F.scrollf:SetPoint("TOPLEFT"    ,WOEZ_F.margt, "BOTTOMLEFT",0,0)
WOEZ_F.scrollf:SetPoint("BOTTOMRIGHT",WOEZ_F.margb, "TOPRIGHT"  ,0,0)
WOEZ_F.scrollf_f  = WOEZ_O:FADE("WOEZscrollffade",WOEZ_F.scrollf,true,.6)

WOEZ_F.scrollb    = WOEZ_O:FRAM("WOEZscrollb","Slider",WOEZ_F.scrollf,"UIPanelScrollBarTemplate",
                                "TOPLEFT", WOEZ_F.main,"TOPRIGHT", 4, -(WOEZ_D.fonts.TXT_14))
WOEZ_F.scrollb:SetPoint("BOTTOMLEFT", WOEZ_F.main, "BOTTOMRIGHT",0,WOEZ_D.fonts.TXT_14) 
WOEZ_F.scrollb:SetMinMaxValues(1, 200) 
WOEZ_F.scrollb:SetValueStep(10) 
WOEZ_F.scrollb:SetValue(0) 
WOEZ_F.scrollb.scrollStep = 10 

WOEZ_F.scrollb:SetScript("OnValueChanged",function (self, value) self:GetParent():SetVerticalScroll(value) end) 

WOEZ_F.scrollb                  :SetWidth( WOEZ_D.fonts.TXT_14)  
WOEZ_F.scrollb.ThumbTexture     :SetWidth( WOEZ_D.fonts.TXT_14)     
WOEZ_F.scrollb.ThumbTexture     :SetHeight(WOEZ_D.fonts.TXT_14)
WOEZ_F.scrollb.ScrollDownButton :SetWidth( WOEZ_D.fonts.TXT_14) 
WOEZ_F.scrollb.ScrollDownButton :SetHeight(WOEZ_D.fonts.TXT_14)
WOEZ_F.scrollb.ScrollUpButton   :SetWidth( WOEZ_D.fonts.TXT_14)   
WOEZ_F.scrollb.ScrollUpButton   :SetHeight(WOEZ_D.fonts.TXT_14)

-- -----------------------------------------------------------------------------
-- CHILD
-- -----------------------------------------------------------------------------

WOEZ_F.child      = WOEZ_O:FRAM("WOEZchild","Frame",WOEZ_F.scrollf)
WOEZ_F.child:SetSize(1,1) 

WOEZ_F.txtwidth   = WOEZ_O:FRAM("WOEZrosterwidth","Frame",WOEZ_F.child,nil,"TOPLEFT",0,0,nil,nil,WOEZ_D.fonts.TXT_14,WOEZ_D.fonts.TXT_14)
WOEZ_F.txtlevel   = WOEZ_O:FRAM("WOEZrosterlevel","Frame",WOEZ_F.child,nil,"TOPLEFT",WOEZ_F.txtwidth,"TOPRIGHT",nil,nil,WOEZ_D.fonts.TXT_14,WOEZ_D.fonts.TXT_14)

WOEZ_F.scrollf:SetScrollChild(WOEZ_F.child)
WOEZ_F.scrollf:SetScript("OnMouseWheel", function (self, value) value = value*-1 val = WOEZ_F.scrollb:GetValue()+value*10 WOEZ_F.scrollb:SetValue(val) end)
WOEZ_F.scrollb:SetScript("OnMouseWheel", function (self, value) value = value*-1 val = WOEZ_F.scrollb:GetValue()+value*10 WOEZ_F.scrollb:SetValue(val) end)

-- -----------------------------------------------------------------------------
-- NO ELVUI VISUAL
-- -----------------------------------------------------------------------------

if not ElvUI then 

    local insideBG = {  edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", edgeSize = 14 };

    WOEZ_F.main       :SetBackdrop(insideBG) 
    WOEZ_F.progress   :SetBackdrop(insideBG) 
end 

-- -----------------------------------------------------------------------------